from HTMLDOMImplementation import HTMLDOMImplementation

import string

FEATURES_MAP = {'CORE':2.0,
                'XML':2.0,
                'TRAVERSAL':2.0,
                'EVENTS':2.0,
                'MUTATIONEVENTS':2.0,

                'UIEVENTS':2.0,
                'MOUSEEVENTS':2.0,
                'HTMLEVENTS':2.0,
                }

try:
    from xml.dom import Range
except:
    pass
else:
    FEATURES_MAP['RANGE'] = 2.0

class BrowserHTMLDOMImplementation(HTMLDOMImplementation):
    def hasFeature(self, feature, version=''):
        featureVersion = FEATURES_MAP.get(string.upper(feature))
        if featureVersion:
            if version and float(version) != featureVersion:
                return 0
            return 1
        return 0

    def createHTMLDocument(self, title):
        from HTMLDocument import HTMLDocument
        doc = HTMLDocument()
        h = doc.createElement('HTML')
        doc.appendChild(h)
        doc._set_title(title)
        return doc

    def _4dom_createHTMLCollection(self, list=None):
        from HTMLCollection import HTMLCollection
        return HTMLCollection(list)

    def _4dom_createHTMLOptionsCollection(self, list=None):
##         from HTMLOptionsCollection import HTMLOptionsCollection
##         return HTMLOptionsCollection(list)
        raise NotImplementedError()

##     def _4dom_createNamedNodeMap(self, owner=None):
##         from HTMLNamedNodeMap import HTMLNamedNodeMap
##         return HTMLNamedNodeMap(owner)


implementation = BrowserHTMLDOMImplementation()
