from xml.dom.ext.reader import Sgmlop, HtmlLib
import BrowserHTMLDOMImplementation

# allows setting DOMImplementation to use
class DOMImplParser(Sgmlop.HtmlParser):
    def __init__(self, implementation=None):
        if implementation is None:
            self.__implementation = BrowserHTMLDOMImplementation.implementation
        else:
            self.__implementation = implementation
        Sgmlop.HtmlParser.__init__(self)

    def initState(self, ownerDoc=None, charset=''):
        self._ownerDoc = ownerDoc or \
                         self.__implementation.createHTMLDocument('')
        self._charset = charset or Sgmlop.DEFAULT_CHARSET
        self.rootNode = self._ownerDoc.createDocumentFragment()
        self._stack = [self.rootNode]
        self._hasHtml = 0


class DOMImplReader(HtmlLib.Reader):
    def __init__(self, implementation=None):
        self.parser = DOMImplParser(implementation=implementation)


def FromHtmlStream(fp, ownerDoc=None, charset=''):
    return DOMImplReader(implementation).fromStream(fp, ownerDoc, charset)


def FromHtmlFile(fileName, ownerDoc=None, charset=''):
    return DOMImplReader(implementation).fromUri(fileName, ownerDoc, charset)


def FromHtmlUrl(url, ownerDoc=None, charset=''):
    return DOMImplReader(implementation).fromUri(url, ownerDoc, charset)


def FromHtml(text, ownerDoc=None, charset='', implementation=None):
    return DOMImplReader(implementation).fromString(text, ownerDoc, charset)
